﻿package MT::Plugin::PickupDate;
use strict;
use MT;
use MT::Plugin;
our $VERSION = '0.1';
use base qw( MT::Plugin );

@MT::Plugin::PickupDate::ISA = qw( MT::Plugin );

my $plugin = new MT::Plugin::PickupDate ( {
    name => 'PickupDate',
    'version' => $VERSION,
} );

MT->add_plugin( $plugin );

sub init_registry {
    my $plugin = shift;
    $plugin->registry ( {
        callbacks => {
            'cms_post_import.entry'
                => \&_cms_post_import,
            'cms_post_import.page'
                => \&_cms_post_import,
        },
   } );
}

sub _cms_post_import {
    my ( $cb, $app, $entry, $path, $data ) = @_;
    if ( $data =~ m!<p\sid="date">(.*?)</p>! ) {
        my $date = $1;
        if ( $date ) {
            if ( $date =~ /([0-9]{4})年([0-9]{1,2})月([0-9]{1,2})日/ ) {
                my $y = $1;
                my $m = $2;
                my $d = $3;
                my $ts = sprintf( "%04d%02d%02d000000", $y, $m, $d );
                $entry->authored_on( $ts );
                $entry->save or die $entry->errstr;
            }
        }
    }
}

1;